'use client'

import { useEffect, useState } from "react";
import { checkUsername } from "./functions";
import { useContext } from "react";
import { UserContext } from "../../contexts/UserContext";
import { validationAll } from "daraman-nextjs-validation-inputs";
import { SubmitButton, TextInput } from "daraman-nextjs-bootstrap-form-elements";


const GetUsername = ({step,setStep}) =>{

    const {user,setUser} = useContext(UserContext);
    const [isLoading,setIsLoading] = useState(false);

    const handleChange = (e) =>{
        const {name,value} = e.target;
        setUser((prev)=>({
            ...prev,
            [name]:value
        }))
    }

    useEffect(() => {
        setUser((prev) => ({
            ...prev,
            ['Username']:user.Mobile
        }))
    },[user.Mobile]);
   
   
    useEffect(() => {
        user.Mobile.length == 11 ? submit() : true;
    },[user.Mobile]);
    

    const submit = async () =>{
        setIsLoading(true);
        return await validationAll().then(async re =>{
            return await checkUsername(user).then(res =>{
                setUser((prev) =>({
                    ...prev,
                    authenticationToken:res.authenticationToken,
                    isRegister:res.is_register,
                }))
                setIsLoading(false);
                setStep(2);
                return true;
            }).catch(e =>{
                // Toaster(e.Message);
                setIsLoading(false); 
            })
            

            
        }).catch(e=>{
            // Toaster('خطا های مربوط به فرم را برطرف کنید');
            setIsLoading(false);
        }) 
        
    }
    
    return (
        <div className="login-form steps active" id="step-1">
                        <div className="detail">
                            <h2>ورود | ثبت نام</h2>
                            <span>سلام !</span>
                            <p>شماره موبایل خود را برای ورود به پنل کاربری  و یا ثبت نام وارد نمایید.</p>
                        </div>
                        

                        <TextInput type="text"
                            name="Mobile"
                            val={user.Mobile}
                            iconClass="bi bi-person"
                            validationRule="required phone"
                            onChange={handleChange}
                            
                        />
                        
                        <div className="submit-form">
                            <SubmitButton text={'ورود / ثبت نام'} isDisabled={isLoading} isLoading={isLoading} callback={submit} />
                            {/* <button id="login-username" type="button" className="btn btn-block btn-submit">ورود</button> */}
                        </div>
                    </div>
    )
}

export default GetUsername;